const canvas = document.getElementById("gameCanvas");
const ctx = canvas.getContext("2d");


const playerImg = new Image();
const powerupImg = new Image();
const enemyImg = new Image();
const isFastEnemyImg = new Image();
const planetImg = new Image();
const boomImg = new Image();
const enemyBoomImg = new Image();
const planetBoomImg = new Image();

const backgrounds = ["kep3.jpg", "kep4.jpg", "kep5.jpg", "kep6.jpg"];
let currentBackgroundIndex = 0;

const backgroundmusics = ["background_2.mp3", "background_3.mp3", "background_4.mp3", "background_5.mp3", "background_1.mp3"];
let backgroundMusic = new Audio("background_1.mp3");
//let currentMusicIndex = 0;
//backgroundMusic = backgroundmusics[currentMusicIndex];

backgroundMusic.loop = true;
backgroundMusic.volume = 0.3;



boomImg.src = 'boom.png';  // A robbanás képének helye
enemyBoomImg.src = 'enemyexplode.png';  // A robbanás képének helye
planetBoomImg.src = 'planetexplode.png';  // A robbanás képének helye

playerImg.src = "player.png"; // A kép elérési útvonala
enemyImg.src = "enemy.png"; // A kép elérési útvonala
isFastEnemyImg.src = "fastenemy.png"; // A kép elérési útvonala
powerupImg.src = "powerup.png"; // A kép elérési útvonala
planetImg.src = "planet.png"; // A kép elérési útvonala


const shootSound = new Audio("shot.mp3"); // A hangfájl elérési útvonala
const explosionSound = new Audio("explosion.mp3"); // A hangfájl elérési útvonala
const playerexplosionSound = new Audio("player_boom.mp3"); // A hangfájl elérési útvonala
const bonusSound = new Audio("bonus.mp3"); // A hangfájl elérési útvonala
const powerupSound = new Audio("powerup.mp3"); // A hangfájl elérési útvonala
const planethitSound = new Audio("planethit.mp3"); // A hangfájl elérési útvonala

const bonusImg = new Image();
bonusImg.src = "bonus.png"; // A kép elérési útvonala
const bonuses = []; // bonus-ok tárolása
let bonusInterval = 16234; // bonus generálás intervalluma (10 másodpercenként)
let lastBonusTime = 0; // Az utolsó bonus generálásának ideje
let bonusActive = false;
let bonusDuration = 5000;
let bonusSpeed = 2;


const boomEffects = []; // Itt tároljuk a robbanásokat




let backgroundImage = new Image();
backgroundImage.src = backgrounds[currentBackgroundIndex];


let showBoom = false;  // A robbanás állapota
let boomStartTime = 0; // Az időpont, amikor a robbanás elindul


//képek manipulációja


//képek manipulációja vége
















const player = {
    x: canvas.width / 2 - 20,
    y: canvas.height - 60,
    width: 40,
    height: 40,
    speed: 5
};

let bulletColor = "Blue";


let intervalId;
let isVPressed= false;
const vButtonShotIntervalDefault = 300;
let vButtonShotInterval = 300;


const bullets = [];
let gameMode = "N";
let enemies = [];
let Planets = [];
const powerUps = []; // Power-up-ok tárolása
let powerupDuration = 5000;
let powerupDurationUpgradeTime = 0;
let planetDestructionScore = 8000;

let powerUpInterval = 10000; // Power-up generálás intervalluma (10 másodpercenként)
let lastPowerUpTime = 0; // Az utolsó power-up generálásának ideje
let enemypoint = 20; //Normál ellenségek értéke
let fastenemypoint = 40; //Gyors ellenségek értéke
let enemySpeed = 1;



let easyMode = false;
const easyModeEnemySpeed = enemySpeed * 0.6;
const easyModeFastEnemySpeed = enemySpeed * 1.2;
const easyModeFastenemypoint = enemypoint * 1.5;
const easyModeEnemypoint = enemypoint * 0.5;


let hardcoreMode = false;
const hardcoreModeEnemySpeed = enemySpeed * 0.8;
const hardcoreModeFastEnemySpeed = hardcoreModeEnemySpeed * 1.3;
const hardcoreModeEnemypoint = enemypoint * 1.5;
const hardcoreModeFastEnemypoint = hardcoreModeEnemypoint * 1.5;



let fastEnemySpeed = enemySpeed * 1.5; // Gyorsabb ellenségek sebessége 10%-kal gyorsabb
let isShooting = false;
let score = 0;
let collisionCount = 5; // Ütközésszámláló induló értéke (pl. 10)

let spawnInterval = 500; // Kezdeti intervallum (1000ms)
let spawnIntervalDescRate = 0.95;
let spawnTimer = 0; // Időzítő, amely meghatározza, mikor generálódjon egy új ellenség
let spawnIntervalPoints = 500;
const minimalSpawnInterval = 10;

let enemySpeedMultiplier = 1.2;
const maximalEnemySpeed = 30;
let powerupDurationUpgradeScore = 0;
const maxEnemySpeed = 10.0

let enemySpeedupPoints = 1000;
let lastIncreaseScore = 0; // Az utolsó emelésnél elért pontszámot tárolja

//let lastScoreMultipleOf500 = 0; // Legutolsó 1000-es többszörös értéke
let lastScoreMultipleOf1000 = 0; // Legutolsó 2000-es többszörös értéke


let doubleShotActive = false; // Jelzi, hogy a dupla lövedék aktív-e




// Játékos mozgatása
function movePlayer() {
    if (keys.ArrowLeft && player.x > 0) player.x -= player.speed;
    if (keys.ArrowRight && player.x < canvas.width - player.width) player.x += player.speed;
}

function drawBackground() {
    ctx.drawImage(backgroundImage, 0, 0, canvas.width, canvas.height);
}


//Hangok kezelese
function startBackgroundMusic() {
    backgroundMusic.play().catch((error) => {
        console.log("Nem lehet automatikusan elindítani a zenét. Interakció szükséges.", error);
    });
}

function stopBackgroundMusic() {
    backgroundMusic.pause();
    backgroundMusic.currentTime = 0;
}

window.onload = () => {
startBackgroundMusic();
};





// Bonus kezelese

// Bonus létrehozása
function createBonus() {
    const x = Math.random() * (canvas.width - 60);
    const y = 0; // Kezdő Y pozíció
    const width = 40;
    const height = 40;
    const color = "yellow";

    bonuses.push({ x, y, width, height, color });
}

// bonus mozgása
function moveBonuses() {
    bonuses.forEach(bonus => {
        bonus.y += bonusSpeed; // Sebesség lefelé
    });
}

// Bonus ütközés ellenőrzése
function checkBonusCollision() {
    bonuses.forEach((bonus, index) => {
        if (
            player.x < bonus.x + bonus.width &&
            player.x + player.width > bonus.x &&
            player.y < bonus.y + bonus.height &&
            player.y + player.height > bonus.y
        ) {
            bonusActive = true; // Képesség aktiválása
	    bonusSound.play();
	    enemypoint = enemypoint * 2;
	    fastenemypoint = fastenemypoint * 2;
            setTimeout(() => {
                bonusActive = false; // 5 másodperc után deaktiválódik
		enemypoint = enemypoint / 2;
            	fastenemypoint = fastenemypoint / 2;
            }, bonusDuration); // 5 másodpercig aktív
            bonuses.splice(index, 1); // bonus eltávolítása
        }
    });
}



//bonus vége





//háttér változtatás kódja
function changeBackground() {
    currentBackgroundIndex++;
    if (currentBackgroundIndex >= backgrounds.length) {
        currentBackgroundIndex = 0; // Visszatérés az első képhez
//	console.log('Visszatertunk a 0-s kepindexre');
    }
    backgroundImage.src = backgrounds[currentBackgroundIndex];
//    console.log('Kepfrissites megtortent erre az indexre:', currentBackgroundIndex);


}

//ROBBANÁSOK KEZELÉSE

//robbanások rajzolásának függvénye
function drawBoomEffects(ctx) {
    boomEffects.forEach(boom => {
        ctx.drawImage(boom.img, boom.x, boom.y, boom.width, boom.height);
    });
}


function addBoomEffect(img, x, y, width = 50, height = 50) {
    // Új robbanási effekt hozzáadása
    boomEffects.push({ img, x, y, width, height });

    // 0.5 másodperc után töröljük az effektet
    setTimeout(() => {
        const index = boomEffects.indexOf(boomEffects.find(b => b.x === x && b.y === y));
        if (index !== -1) boomEffects.splice(index, 1);
    }, 500);
}



//ROBBANÁSOK VÉGE





// Lövés hozzáadása
function shoot() {
    if (doubleShotActive) {
        // Két lövedék kilövése
	if ( score > planetDestructionScore ){ bulletColor = "green" } else {bulletColor = "blue"} 
        bullets.push({ x: player.x, y: player.y, width: 10, height: 20, color: bulletColor, speed: 9 });
        bullets.push({ x: player.x + player.width - 10, y: player.y, width: 10, height: 20, color: bulletColor, speed: 6 });
	shootSound.play();
    } else {
        // Egy lövedék kilövése
        bullets.push({ x: player.x + player.width / 2 - 5, y: player.y, width: 10, height: 20, color: "red", speed: 7 });
	shootSound.play();
    }
}

function createPlanet() {
    const x = Math.random() * (canvas.width - 120);
    const y = 0; // Kezdő Y pozíció
    const width = 120;
    const height = 120;
//    const color = "red";

    Planets.push({ x, y, width, height });
    console.log("Planet létrehozva");

}

// Planet mozgása
function movePlanets() {
    Planets.forEach(Planet => {
        Planet.y += 1; // Sebesség lefelé
    });
}


function playerexplode() {
            showBoom = true;  // Indítsuk el a robbanás animációt
            boomStartTime = Date.now();  // Rögzítsük az időpontot, amikor a robbanás kezdődött
	    clearEnemies();
	    collisionCount--;
	    playerexplosionSound.play();
         if (collisionCount <= 0) { // Ha a számláló eléri a 0-t, a játék véget ér
	    stopBackgroundMusic();
            document.getElementById("nameModal").style.display = 'block'; // Név modal megjelenítése
                console.log("név beküldve");
	}

}



// Planet ütközés ellenőrzése
function checkPlanetCollision() {
    Planets.forEach((Planet, index) => {
        if (
            player.x < Planet.x + Planet.width &&
            player.x + player.width > Planet.x &&
            player.y < Planet.y + Planet.height &&
            player.y + player.height > Planet.y
        ) {
	    playerexplode();
	    score = score - 200;

            }
    });
}




// Power-up (jutalom) létrehozása
function createPowerUp() {
    const x = Math.random() * (canvas.width - 60);
    const y = 0; // Kezdő Y pozíció
    const width = 60;
    const height = 60;
    const color = "yellow";

    powerUps.push({ x, y, width, height, color });
	if ( score > 10000 && powerupDurationUpgradeScore < 1 ) { 
		powerupDuration = 9000; 
		powerupDurationUpgradeTime = score;
	}
}

// Power-up mozgása
function movePowerUps() {
    powerUps.forEach(powerUp => {
        powerUp.y += 1; // Sebesség lefelé
    });
}

// Power-up ütközés ellenőrzése
function checkPowerUpCollision() {
    powerUps.forEach((powerUp, index) => {
        if (
            player.x < powerUp.x + powerUp.width &&
            player.x + player.width > powerUp.x &&
            player.y < powerUp.y + powerUp.height &&
            player.y + player.height > powerUp.y
        ) {
            doubleShotActive = true; // Képesség aktiválása
	    powerupSound.play();
            setTimeout(() => {
                doubleShotActive = false; // 5 másodperc után deaktiválódik
            }, powerupDuration); // 5 másodpercig aktív
            powerUps.splice(index, 1); // Power-up eltávolítása
        }
    });
}

// Ellenség generálása
function spawnEnemy() {
    const x = Math.random() * (canvas.width - 40);
    const isFastEnemy = Math.random() < 0.5;
    enemies.push({
        x,
        y: 0,
        width: 40,
        height: isFastEnemy ? 60 : 40, // Ha gyors ellenség, legyen magasabb
	image: isFastEnemy ? isFastEnemyImg : enemyImg,
//        color: isFastEnemy ? "orange" : "green",
        speed: isFastEnemy ? fastEnemySpeed : enemySpeed
    });

}

function clearEnemies() {
	enemies = []; // Ürítsd ki az ellenségek tömbjét
	Planets = []; // Ürítsd ki a planetek tömbjét
	console.log("Minden ellenség eltávolítva!"); // Ezt a sor csak a teszteléshez van
}





// Játékos és ellenség ütközésének ellenőrzése
function checkPlayerCollisions() {
    enemies.forEach((enemy, index) => {
        if (
            player.x < enemy.x + enemy.width &&
            player.x + player.width > enemy.x &&
            player.y < enemy.y + enemy.height &&
            player.y + player.height > enemy.y
        ) {
	    playerexplode();
        }
    });
}

// Ütközések ellenőrzése (lövedék és ellenség)
function checkCollisions() {
    bullets.forEach((bullet, bIndex) => {
        enemies.forEach((enemy, eIndex) => {
            if (
                bullet.x < enemy.x + enemy.width &&
                bullet.x + bullet.width > enemy.x &&
                bullet.y < enemy.y + enemy.height &&
                bullet.y + bullet.height > enemy.y
            ) {
                bullets.splice(bIndex, 1);
                enemies.splice(eIndex, 1);
		explosionSound.play();
                addBoomEffect(enemyBoomImg, enemy.x, enemy.y);


                if (enemy.speed === fastEnemySpeed) {
                    score += fastenemypoint;
                } else {
                    score += enemypoint;
                }
            }
        });
    });

//bolygo interakciok eleje

	bullets.forEach((bullet, bIndex) => {
        Planets.forEach((Planet, eIndex) => {
            if (
                bullet.x < Planet.x + Planet.width &&
                bullet.x + bullet.width > Planet.x &&
                bullet.y < Planet.y + Planet.height &&
                bullet.y + bullet.height > Planet.y
            ) {
//A bolygonak ütköző lövedékek mindig megsemmisülnek. 5000 pont felett ütközéskor a bolygó is
                bullets.splice(bIndex, 1);
		planethitSound.play();
		if ( score > planetDestructionScore && doubleShotActive && !hardcoreMode ){
		addBoomEffect(planetBoomImg, Planet.x, Planet.y, Planet.width, Planet.height);
                Planets.splice(eIndex, 1);
		score = score - 2000;}
//		collisionCount = collisionCount + 1;
            }
            });
	    });
// bolygo interakciok vege


}




// A robbanás kirajzolása
function drawBoom() {
    if (showBoom) {
        const boomDuration = 500;  // A robbanás időtartama (1 másodperc)
        const currentTime = Date.now();
        if (currentTime - boomStartTime < boomDuration) {
            // Rajzoljuk a robbanást a játékos pozíciójára
            ctx.drawImage(boomImg, player.x-50, player.y-50, player.width+100, player.height+100);
        } else {
            // Ha eltelt 1 másodperc, állítsuk le a robbanás megjelenítését
            showBoom = false;
        }
    }
}






// Név beküldése
document.getElementById("submitName").addEventListener("click", () => {
    let playerName = document.getElementById("playerName").value;

    if (playerName && score > 0 ) {  // Ellenőrizzük, hogy a név, pontszám és kategória is meg legyen adva
        // Küldjük a pontszámot, nevet és kategóriát a szerverre
        fetch("http://keczelialex.hu:3000/save-score", {
            method: "POST",
            headers: {
                "Content-Type": "application/json"
            },
            body: JSON.stringify({
                playerName: playerName,
                score: parseInt(score),  // A pontszámot integerre alakítjuk
                category: gameMode       // A kategória is küldve lesz
            })
        })
        .then(response => response.json())
        .then(data => {
            alert("Pontszám mentve!");
            document.location.reload(); // Újratöltés a játék újraindításához
        })
        .catch(error => {
            console.error("Hiba történt:", error);
        });
    } else {
        alert("Kérlek, add meg a neved!");
    }
});






//Normál mód indítása
document.getElementById("normalmode").addEventListener("click", () => {
startBackgroundMusic();
canvas.focus();
});


//Normál mód indítása
document.getElementById("stopmusic").addEventListener("click", () => {
stopBackgroundMusic();
document.body.focus();
score = 0;
clearEnemies();
});




// Könnyű mód beállítása
document.getElementById("easymode").addEventListener("click", () => {
	document.body.focus();
	startBackgroundMusic();
	easyMode = true;
	gameMode = "S";
        hardcoreMode = false;
	clearEnemies();
        enemySpeed = easyModeEnemySpeed;
        fastEnemySpeed = easyModeFastEnemySpeed;
        fastenemypoint = easyModeFastenemypoint;
        enemypoint = easyModeEnemypoint;
        score = 0;
	spawnInterval = 2000;
	spawnIntervalPoints = 100;
	enemySpeedupPoints = 500;
	enemySpeedMultiplier = 1.02;
	spawnIntervalDescRate = 0.98;
        collisionCount = 6;
	console.log("könnyű mód kiválasztva");
});



// Hardcore mód beállítása
document.getElementById("hardcoremode").addEventListener("click", () => {
	document.body.focus();
	startBackgroundMusic();
        hardcoreMode = true;
	gameMode = "H";
        easyMode = false;
        clearEnemies();
        enemySpeed = hardcoreModeEnemySpeed;
        fastEnemySpeed = hardcoreModeFastEnemySpeed;
        fastenemypoint = hardcoreModeFastEnemypoint;
        enemypoint =  hardcoreModeEnemypoint;
        score = 0;
	powerUpInterval = 15000;
        spawnInterval = 800;
        spawnIntervalPoints = 200;
        enemySpeedupPoints = 1000;
        enemySpeedMultiplier = 1.1;
        spawnIntervalDescRate = 0.9;
        collisionCount = 1;
        console.log("hardcore mód kiválasztva");
});






// Játék rajzolása
function draw() {
    ctx.clearRect(0, 0, canvas.width, canvas.height);
drawBackground(); // Háttér kirajzolása

    // Játékos rajzolása képpel
    ctx.drawImage(playerImg, player.x, player.y, player.width, player.height);


    drawBoomEffects(ctx);

    // Lövedékek rajzolása
    bullets.forEach(bullet => {
        ctx.fillStyle = bullet.color;
        ctx.fillRect(bullet.x, bullet.y, bullet.width, bullet.height);
    });

    // Ellenségek rajzolása
    enemies.forEach(enemy => {
	ctx.drawImage(enemy.image, enemy.x, enemy.y, enemy.width, enemy.height);
//        ctx.fillStyle = enemy.color;
//        ctx.fillRect(enemy.x, enemy.y, enemy.width, enemy.height);
    });

//bónuszok rajzolása
    bonuses.forEach(bonus => {
        ctx.drawImage(bonusImg, bonus.x, bonus.y, bonus.width, bonus.height);
    });


    // Power-up-ok rajzolása
    powerUps.forEach(powerUp => {
//        ctx.fillStyle = powerUp.color;
//        ctx.fillRect(powerUp.x, powerUp.y, powerUp.width, powerUp.height);
	ctx.drawImage(powerupImg, powerUp.x, powerUp.y, powerUp.width, powerUp.height);
    });

    // Planetek rajzolása
    Planets.forEach(Planet => {
//        ctx.fillStyle = Planets.color;
//        ctx.fillRect(Planet.x, Planet.y, Planet.width, Planet.height);
        ctx.drawImage(planetImg, Planet.x, Planet.y, Planet.width, Planet.height);
    });


    // Pontszámláló és ütközésszámláló kirajzolása
    ctx.fillStyle = "white";
    ctx.font = "20px Arial";
    ctx.fillText("Pontszám: " + score, 10, 30);
    ctx.fillText("Élet: " + collisionCount, 10, 60); // Az ütközésszámláló "Életként" megjelenítve
    ctx.fillText("Spawn Interval: " + Math.round(spawnInterval), 10, 90); // spawnInterval kiírása
    ctx.fillText("Enemy speed: " + Math.round(enemySpeed), 10, 120); // enemySpeed kiírása
    if (bonusActive)
    ctx.fillText("Bónusz aktív! ", 10, 150);


    drawBoom();

}


// Mozgás frissítése
function update() {
    movePlayer();
    bullets.forEach((bullet, index) => {
        bullet.y -= bullet.speed;
        if (bullet.y < 0) bullets.splice(index, 1);
    });
//8000 pont felett a PowerUp időtartama alatt folyamatos duplalövés van
	if ( doubleShotActive && score > 8000) { shoot(); }

    enemies.forEach((enemy, index) => {
        enemy.y += enemy.speed;
        if (enemy.y > canvas.height) enemies.splice(index, 1);
    });

    moveBonuses();
    movePowerUps();
    movePlanets();
    checkCollisions();
    checkPlayerCollisions(); // Ellenőrizze a játékos ütközéseit is
    checkPowerUpCollision(); // Power-up ütközések ellenőrzése
    checkPlanetCollision(); // Planet ütközések ellenőrzése
    checkBonusCollision(); // Bonus ütközések ellenőrzése

}


let lastTime = 0; // Az utolsó frissítés ideje
const targetFPS = 60;
const targetInterval = 1000 / targetFPS; // 1000 ms / 60 FPS = 16.67 ms

// Fő ciklus
function gameLoop(timestamp) {



// Számold ki az eltelt időt a két frame között
    const deltaTime = timestamp - lastTime;

    // Ha a deltaTime elérte a kívánt frissítési időt
    if (deltaTime >= targetInterval) {
        lastTime = timestamp - (deltaTime % targetInterval);  // Frissítsd az utolsó időpontot



if (collisionCount > 0 ){

    update();
    draw();

    if (performance.now() - lastPowerUpTime > powerUpInterval) {
        createPowerUp();
        lastPowerUpTime = performance.now(); // Frissítjük az utolsó power-up létrehozásának idejét
    }

    if (performance.now() - lastBonusTime > bonusInterval) {
        createBonus();
        lastBonusTime = performance.now(); // Frissítjük az utolsó bonus létrehozásának idejét
    }


    // Ha elértük a 1000 pontot, csökkentjük az intervallumot
    if (score >= lastIncreaseScore + spawnIntervalPoints && spawnInterval > minimalSpawnInterval ) {
	lastIncreaseScore = score;
        spawnInterval = spawnInterval * spawnIntervalDescRate; // 10%-kal gyorsítjuk az ellenség spawn sebességét
	createPlanet();
	vButtonShotInterval = vButtonShotInterval * 0.95;

    }

    if (score >= lastScoreMultipleOf1000 + enemySpeedupPoints && enemySpeed < maximalEnemySpeed ) {
        lastScoreMultipleOf1000 = score;
        enemySpeed = enemySpeed * enemySpeedMultiplier; //20%-al gyorsulnak az ellenségek
        bonusSpeed = bonusSpeed * enemySpeedMultiplier; //A bonusok esési sebessége az ellenségével együtt nő
	changeBackground();
	spawnIntervalPoints = spawnIntervalPoints * 1.1;
        fastEnemySpeed = enemySpeed * 1.5;
	enemypoint = enemypoint + 5;
	fastenemypoint = enemypoint * 2.0;
//	createPlanet();
    }
    // Frissítjük a spawn időzítőt
    spawnTimer += 16;

    if (spawnTimer >= spawnInterval) {
        spawnEnemy();
        spawnTimer = 0;
    }

    movePowerUps();
    checkPowerUpCollision();

    requestAnimationFrame(gameLoop);
};

}


    requestAnimationFrame(gameLoop); // Újraindítjuk a következő frame-t

}

// Billentyűk figyelése
const keys = {};
window.addEventListener("keydown", e => {
    keys[e.key] = true;
    if (e.key === " " && !isShooting) {
        shoot();
        isShooting = true;
    }
});

window.addEventListener("keyup", e => {
    keys[e.key] = false;
    if (e.key === " ") isShooting = false;
});


// V billentyű lenyomása
document.addEventListener('keydown', (event) => {
    if ((event.key === 'v' || event.key === 'V') && !isVPressed) { // Ellenőrizzük, hogy a 'V' billentyűt nyomták-e le
        isVPressed = true;
        // Indítjuk az intervallumot, ami a műveletet folyamatosan végrehajtja
        intervalId = setInterval(vButtonPressed, vButtonShotInterval); // Művelet 500 ms-onként
    }
});

// V billentyű felengedése
document.addEventListener('keyup', (event) => {
    if ((event.key === 'v' || event.key === 'V') && isVPressed) { // Ha a 'V' billentyűt engedték fel
        isVPressed = false;
        // Megállítjuk az intervallumot, amikor a 'V' billentyűt felengedik
        clearInterval(intervalId); // Leállítjuk az intervallumot
//	vButtonShotInterval = vButtonShotIntervalDefault; //vbutton shot interval visszaállítása alapértékre
//        console.log('V billentyű felengedve, művelet leállt');
    }
});

// V billentyű nyomva tartása közben végrehajtott művelet
function vButtonPressed(){
    shoot(); // Művelet végrehajtása
//    vButtonShotInterval *= 0.99; // Csökkentjük az intervallumot

//    console.log("vButtonShotInterval:", vButtonShotInterval);

    // Ha még mindig lenyomva van a 'v' billentyű, frissítjük az intervallumot
    if (isVPressed) {
        clearInterval(intervalId); // Megállítjuk az előző intervallumot
        intervalId = setInterval(vButtonPressed, vButtonShotInterval); // Újraindítjuk a műveletet a csökkentett intervallummal
    }
}






// Ellenségek időzítése (kezdetben 1000ms)
gameLoop();

